
<!-- Warning: This file has been autogenerated by tools/makedoc.py. Manual edits will be overwritten. -->
<html>
    <head>
        <title>freesmartphone.org GSM Device Interface</title>
        <link rel="stylesheet" type="text/css" href="http://git.freesmartphone.org/?p=specs.git;a=blob_plain;f=html/style.css;hb=HEAD" />
    </head>
    <body>
    <div class="topbox">freesmartphone.org Framework DBus Interface Specification</div>


<h1>org.freesmartphone.GSM.Device</h1><h2>Description</h2>
<p>The Device interface is used to give information about the GSM  or CDMA device and its capabilities. Use it also to enable or  disable the RF subsystem (which is mandatory for implementing  a flight mode).</p>
<h2>Namespace</h2>
<p><tt>org.freesmartphone.GSM.Device</tt></p>
<h2>Methods</h2><ul>
<li><a href="#GetFunctionality">GetFunctionality</a></li>
<li><a href="#SetFunctionality">SetFunctionality</a></li>
<li><a href="#GetFeatures">GetFeatures</a></li>
<li><a href="#GetDeviceStatus">GetDeviceStatus</a></li>
<li><a href="#GetSpeakerVolume">GetSpeakerVolume</a></li>
<li><a href="#SetSpeakerVolume">SetSpeakerVolume</a></li>
<li><a href="#GetMicrophoneMuted">GetMicrophoneMuted</a></li>
<li><a href="#SetMicrophoneMuted">SetMicrophoneMuted</a></li>
</ul>
<h2>Signals</h2><ul>
<li><a href="#DeviceStatus">DeviceStatus</a></li>
<li><a href="#KeypadEvent">KeypadEvent</a></li>
</ul>
<h2>Properties</h2><i>None</i>
<h2>Errors</h2><i>None</i>
<h1>Methods</h1><h3><a name="GetFunctionality">GetFunctionality</a> ( ) &rarr; sbs</h3>
<p><i>Description:</i> Retrieve the current functionality status of the device. </p><h4>Returns</h4><i>s: level</i><p>The functionality level. Expected values are:  <ul>  <li>"minimal": The device is in maximum powersave mode, SIM access is not possible</li>  <li>"airplane": The device is in airplane mode (RF receivers and transmitters have been turned off), SIM access is possible</li>  <li>"full": The device operates with maximum functionality (all units are powered up).</li>  </ul> </p><i>b: autoregister</i><p>Whether the device tries to maintain registration with a provider.  This parameter is only valid, if level = "full". </p><i>s: pin</i><p>The SIM PIN being used to authenticate if necessary, or an empty string.  This parameter is only valid, if level = "full" or "airplane". </p>
<h3><a name="SetFunctionality">SetFunctionality</a> ( sbs )</h3>
<p><i>Description:</i> Set the functionality status for this device. </p><h4>Parameters</h4><i>s: level</i><p>See <a href="http://docs.freesmartphone.org/org.freesmartphone.GSM.Device.html#GetFunctionality">GetFunctionality</a> </p><i>b: autoregister</i><p>Whether the device should try to maintain registration with a provider.  This parameter is only valid, if level = "full". </p><i>s: pin</i><p>The SIM PIN being used to authenticate if necessary, or an empty string.  This parameter is only valid, if level = "full" or "airplane". </p>
<h3><a name="GetFeatures">GetFeatures</a> ( ) &rarr; a{sv}</h3>
<p><i>Description:</i> Get information about the telephony features supported by this device. </p><h4>Returns</h4><i>a{sv}: features</i><p>The telephony features supported by this device. Valid tuples are:  <ul>  <li>("voice", bool) = true, if the device supports voice calls,</li>  <li>("csd", bool) = true, if the device supports circuit-switched (data) calls,</li>  <li>("gsm", bool) = true, if the device can operate in a GSM network,</li>  <li>("cdma", bool) = true, if the device can operate in a CDMA network,</li>  <li>("pdp", string) = supported pdp classes, if the device supports packet data communication,</li>  <li>("fax", string) = supported fax classes, if the device supports fax communication,</li>  <li>("facilities", string) = supported security facilities.</li>  </ul> </p>
<h3><a name="GetDeviceStatus">GetDeviceStatus</a> ( ) &rarr; s</h3>
<p><i>Description:</i> Retrieve the current device status. SIM commands, such as  <a href="http://docs.freesmartphone.org/org.freesmartphone.GSM.SIM.html#ListPhonebooks">ListPhonebooks</a> can not be performed  before the device is in the status 'alive-sim-ready'. </p><h4>Returns</h4><i>s: status</i><p>The device status. Expected values are:  <ul>  <li>"unknown" = Device status could not be found,</li>  <li>"closed" = Device is present, but not opened,</li>  <li>"initializing" = Device is being opened,</li>  <li>"alive-no-sim" = Device is operating without a SIM card,</li>  <li>"alive-sim-locked" = Device is operating, SIM card is locked,</li>  <li>"alive-sim-unlocked" = Device is operating, SIM card unlocked,</li>  <li>"alive-sim-ready" = Device is operating, SIM card is ready for access,</li>  <li>"alive-registered" = Device is operating and camped to the network,</li>  <li>"suspending" = Device is suspending,</li>  <li>"suspended" = Device is suspended,</li>  <li>"resuming" = Device is resuming,</li>  <li>"closing" = Device is closing.</li>  </ul> </p>
<h3><a name="GetSpeakerVolume">GetSpeakerVolume</a> ( ) &rarr; i</h3>
<p><i>Description:</i> Retrieve the current loudspeaker volume. </p><h4>Returns</h4><i>i: volume</i><p>The volume in percent (0-100). </p>
<h3><a name="SetSpeakerVolume">SetSpeakerVolume</a> ( i )</h3>
<p><i>Description:</i> Set the current loudspeaker volume. </p><p><div class="rationale"><p>This maps to the GSM 07.07 command +CLVL=... see 3GPP TS 07.07 Chapter 8.2.3. </p></div></p><h4>Parameters</h4><i>i: volume</i><p>The volume in percent (0-100). </p>
<h3><a name="GetMicrophoneMuted">GetMicrophoneMuted</a> ( ) &rarr; b</h3>
<p><i>Description:</i> Retrieve whether the microphone is currently muted. </p><p><div class="rationale"><p>This maps to the GSM 07.07 command +CMUT?, see 3GPP TS 07.07 Chapter 8.2.4. </p></div></p><h4>Returns</h4><i>b: muted</i><p>True, if the microphone is muted. False, otherwise. </p>
<h3><a name="SetMicrophoneMuted">SetMicrophoneMuted</a> ( b )</h3>
<p><i>Description:</i> Mute or unmute the microphone. </p><p><div class="rationale"><p>This maps to the GSM 07.07 command +CMUT=... see 3GPP TS 07.07 Chapter 8.2.4. </p></div></p><h4>Parameters</h4><i>b: muted</i><p>True, to mute the microphone. False, otherwise. </p>
<h1>Signals</h1><h3><h3><a name="DeviceStatus">DeviceStatus</a> ( s )</h3><p><i>Description:</i> Sent on a change in device status. </p><h4>Parameters</h4><i>s: status</i><p>The device status. See <a href="http://docs.freesmartphone.org/org.freesmartphone.GSM.Device.html#GetDeviceStatus">GetDeviceStatus</a> for expected values. </p></h3>
<h3><h3><a name="KeypadEvent">KeypadEvent</a> ( sb )</h3><p><i>Description:</i> Sent, when a keypad input event occurs. </p><h4>Parameters</h4><i>s: name</i><p>The name of the event source. </p><i>b: pressed</i><p>True, if the keypad key has been pressed. False, otherwise. </p></h3>

    <hr/>
    <small>
    | Specified 2008-2012 by the <a href="http://www.freesmartphone.org">Freesmartphone.org</a> team. | Join us and discuss further drafts smartphones-standards (at) linuxtogo (dot) org
    </small>
    <hr/>
    </body>
</html>

